﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace SetValueDelay
{
    public partial class Form1 : Form
    {
        private Timer timer;
        private Random random;

        public Form1()
        {
            InitializeComponent();

            random = new Random();
            InitSpread(fpSpread1);

            Load += Form1_Load;
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            timer = new Timer();
            timer.Interval = 50;
            timer.Start();

            timer.Tick += Timer_Tick;
        }

        int row = 0;
        int col = 0;
        int r = 10;

        private void Timer_Tick(object sender, EventArgs e)
        {
            fpSpread1.ActiveSheet.SetValue(row, col, random.Next(r, r * 10));

            col = (col + 1) % fpSpread1.ActiveSheet.ColumnCount;
            if (col == 0)
                row = (row + 1) % fpSpread1.ActiveSheet.RowCount;

            if (row == 0 && col == 0)
                r *= 10;

            if (r * 10 < r)
                r = 1;
        }

        private void InitSpread(FarPoint.Win.Spread.FpSpread spread)
        {
            var sheet = spread.ActiveSheet;
            List<Entity> data = new List<Entity>();
            for (int i = 0; i < 15; ++i)
            {
                data.Add(new Entity(random.Next(1, 10), random.Next(1, 10), random.Next(1, 10), random.Next(1, 10), random.Next(1, 10)));
            }
            sheet.DataSource = data;
        }
    }

    public class Entity
    {
        public int Col1 { get; set; }
        public int Col2 { get; set; }
        public int Col3 { get; set; }
        public int Col4 { get; set; }
        public int Col5 { get; set; }

        public Entity(int val1, int val2, int val3, int val4, int val5)
        {
            Col1 = val1;
            Col2 = val2;
            Col3 = val3;
            Col4 = val4;
            Col5 = val5;
        }
    }
}
